/**
* Copyright © 2016 Magento. All rights reserved.
* See COPYING.txt for license details.
*/
define([
    'jquery',
    'jquery/ui'
], function ($) {
    'use strict';

    $.widget('filoblu.historyScroll', {

        options: {
            product_selector: '.product-item-info',
            storage_key: 'mage-history-product-id',
            pixel_to_remove: 0
        },

        _create: function(){

            var self = this;

            this._super();

            $('body').on('click', self.options.product_selector, function(){
                var url = location.href;
                url = self.replaceUrlParam(url, 'p', $(this).attr('data-page'));
                history.pushState({product: $(this).attr('id')}, url, url);

                if (!window.localStorage) {
                    $.cookie(self.options.storage_key, $(this).attr('id'), {expires: 1, path: '/'});
                }else{
                    localStorage.setItem('mage-history-product-id', $(this).attr('id'));
                }
            });

            if(localStorage.getItem(self.options.storage_key) || $.cookie(self.options.storage_key)){

                var productId = (localStorage.getItem(self.options.storage_key)) ? localStorage.getItem(self.options.storage_key) : $.cookie(self.options.storage_key);

                var product = '#' + productId;

                if($(product).length){

                    var offsetTop = $(product).offset().top;

                    if ('scrollRestoration' in history) {
                        history.scrollRestoration = 'manual';
                    }

                    $('html,body').animate({
                        scrollTop: (offsetTop - self.options.pixel_to_remove) + 'px'
                    });

                    localStorage.setItem(self.options.storage_key, '');
                    $.cookie(self.options.storage_key, null, { path: '/' });
                }
            }
        },

        replaceUrlParam: function (url, paramName, paramValue){
            if(paramValue == null)
            paramValue = '';
            var pattern = new RegExp('\\b('+paramName+'=).*?(&|$)')
            if(url.search(pattern)>=0){
                return url.replace(pattern,'$1' + paramValue + '$2');
            }
            url = url.replace(/\?$/,'');
            return url + (url.indexOf('?')>0 ? '&' : '?') + paramName + '=' + paramValue
        }

    });

    return $.filoblu.historyScroll;
});
